//
//  DTDot.m
//  dots
//
//  Created by Matthew Schettler on 1/17/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "DTDot.h"

@implementation DTDot

#define RANDOM_INT(MIN, MAX) MIN + (arc4random() % (1 + MAX - MIN))

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
        self.image = [UIImage imageNamed:@"ladybug.png"];

        srand(time(0));
        
        speed = 3;
 
        playArea = CGRectMake(0, 0, 320, 460);
        
        // code relys on these being true
        assert(playArea.origin.x == 0);
        assert(playArea.origin.y == 0);
        
        meHalfWidth = self.frame.size.width / 2;
        meHalfHeight = self.frame.size.height / 2;
        
        [self selfSetAngleInDegrees:RANDOM_INT(0, 360)];
        [self moveToRandomPoint];
                
    }
    return self;
}


- (void)moveToRandomPoint {
    
    const int x = RANDOM_INT(60, 250);
    const int y = RANDOM_INT(60, 350);
        
    self.center = CGPointMake(x, y);
}


- (void)selfSetAngleInDegrees:(float)degree {
    
    movingAngleInDegree = degree;
    movingAngle = degreesToRadian(degree);

//    NSLog(@"selfSetAngleInDegrees = %f", degree);

    
}


- (void)doMove {
    
    const float angleBallHitWall = movingAngleInDegree;

    // right bound
    if (self.center.x + meHalfWidth > playArea.size.width) {
        [self selfSetAngleInDegrees:180.0-angleBallHitWall];
        self.center = addToPointThisSpeedAngle(self.center, speed*2, movingAngle);
        [self didBumpWall];
    }
    // left bound
    else if (self.center.x - meHalfWidth < playArea.origin.x) {
        [self selfSetAngleInDegrees:180.0-angleBallHitWall];
        self.center = addToPointThisSpeedAngle(self.center, speed*2, movingAngle);
        [self didBumpWall];
    }
    // top bound
    else if (self.center.y - meHalfWidth < playArea.origin.y) {
        [self selfSetAngleInDegrees:360.0-angleBallHitWall];
        self.center = addToPointThisSpeedAngle(self.center, speed*2, movingAngle);
        [self didBumpWall];
    }
    // bot bound
    else if (self.center.y + meHalfWidth > playArea.size.height) {
        [self selfSetAngleInDegrees:360.0-angleBallHitWall];
        self.center = addToPointThisSpeedAngle(self.center, speed*2, movingAngle);
        [self didBumpWall];
    } else {
        self.center = addToPointThisSpeedAngle(self.center, speed, movingAngle);
    }
    
    
}


- (void)doSmartMove {
    
    
    
}


- (void)didBumpWall {
    
    NSLog(@"did bump wall!");
    
}

@end


CGPoint addToPointThisSpeedAngle(CGPoint point, float speed, float angle) {
    point.x += speed * cos(angle);
    point.y -= speed * sin(angle);
    return point;
}