//
//  DTLine.m
//  dots
//
//  Created by Matthew Schettler on 1/17/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "DTLine.h"

@implementation DTLine

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
        self.backgroundColor = [UIColor clearColor];
        self.frame = CGRectMake(0, 0, 320, 460);
        width = 1;

        
#if OPTIMIZE
#else
        
        const int test0 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(1, 0))));
        
        const int test30 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(sqrt(3)/2, 0.5))));
        const int test45 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(1, 1))));
        const int test60 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(0.5, sqrt(3)/2))));
        const int test90 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(0, 1))));
        
        const int test120 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(-0.5, sqrt(3)/2))));
        const int test135 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(-sqrt(2)/2, sqrt(2)/2))));
        const int test150 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(-sqrt(3)/2, 0.5))));
        const int test180 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(-1, 0))));
        
        const int test210 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(-sqrt(3)/2, -0.5))));
        const int test225 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(-sqrt(2)/2, -sqrt(2)/2))));
        const int test240 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(-0.5, -sqrt(3)/2))));
        const int test270 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(0, -1))));
        
        const int test300 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(0.5, -sqrt(3)/2))));
        const int test315 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(sqrt(2)/2, -sqrt(2)/2))));
        const int test330 = round(radiansToDegrees(angleBetweenPoints(CGPointZero, CGPointMake(sqrt(3)/2, -0.5))));
        
        assert(0 == test0);
        assert(30 == test30);
        assert(45 == test45);
        assert(60 == test60);
        assert(60 == test60);
        assert(60 == test60);
        assert(90 == test90);
        assert(120 == test120);
        assert(135 == test135);
        assert(150 == test150);
        assert(180 == test180);
        assert(210 == test210);
        assert(225 == test225);
        assert(240 == test240);
        assert(270 == test270);
        assert(300 == test300);
        assert(315 == test315);
        assert(330 == test330);

#endif

        
    }
    return self;
}


- (void)setLineFromDot:(DTDot *)dot1 toDot:(DTDot *)dot2 {
    
    assert(dot1);
    assert(dot2);
    
    mydot1 = dot1;
    mydot2 = dot2;

}


- (void)doUpdate {
    
    [self setNeedsDisplay];
    
}

- (void)drawRect:(CGRect)rect {
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    
    CGContextSetLineWidth(context, width);
    
    CGContextSetStrokeColorWithColor(context, [UIColor blackColor].CGColor);
    
    CGContextMoveToPoint(context, mydot1.center.x, mydot1.center.y);
    CGContextAddLineToPoint(context, mydot2.center.x, mydot2.center.y);
    
    CGContextStrokePath(context);
}

@end


float angleBetweenPoints(CGPoint origin, CGPoint second) {
    if (second.x == origin.x && second.y == origin.y) return 0;
    const float dy = second.y - origin.y;
    const float dx = second.x - origin.x;
    float ret = atan2(dy, dx);

    while (ret < 0.0) ret += M_PI*2;
    while (ret > 360.0) ret -= M_PI*2;
    
    return ret;
}


float distanceBetweenPoints(CGPoint first, CGPoint second) {
    float deltaX = second.x - first.x;
    float deltaY = second.y - first.y;
    return sqrt((deltaX*deltaX) + (deltaY*deltaY));
};


CGPoint midPointBetweenPoints(CGPoint first, CGPoint second) {
    return CGPointMake((first.x+second.x)/2, (first.y+second.y)/2);
}
