//
//  ViewController.m
//  dots
//
//  Created by Matthew Schettler on 1/17/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    dots = [NSMutableArray new];
    lines = [NSMutableArray new];
    
    gameInterval = 1; // 1=60 fps, 2=30 fps
        
    [self startGameTimer];

    [self createDots:5];

}


- (void)createDots:(int)count {

    [dots removeAllObjects];
    
    for (int i = 0; i < count; i++) {
        DTDot *dot = [[DTDot alloc] initWithFrame:CGRectMake(0, 0, 16*2, 16*2)];
        [self.view addSubview:dot];
        [dots addObject:dot];
        
        // attach a line
        for (DTDot *otherdot in dots) {
            if (otherdot == dot) continue;

            DTLine *line = [[DTLine alloc] initWithFrame:CGRectZero];
            [line setLineFromDot:dot toDot:otherdot];
            [self.view addSubview:line];
            [lines addObject:line];
            [line release];
            
        }
        
        [dot release];

    }
    
//    DTDot *dot = [dots lastObject];
//    [dot setBackgroundColor:[UIColor redColor]];

}


- (void)startGameTimer {

    if (!running) {

        displayLink = [CADisplayLink displayLinkWithTarget:self selector:@selector(drawView:)];
        [displayLink setFrameInterval:gameInterval];
        [displayLink addToRunLoop:[NSRunLoop currentRunLoop] forMode:NSDefaultRunLoopMode];
		
		running = YES;
	}

}


- (void)drawView:(id)sender {

    for (DTDot *dot in dots) {
        [dot doMove];
    }
    
    for (DTLine *line in lines) {
        [line doUpdate];
    }
    
}

@end



